/* barbre.C
 *
 * Copyright (C) 2002 Matthieu Nottale <matthieu@nottale.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: barbre.C,v 1.3 2006/04/10 21:04:16 cvs Exp $
 *
 */



template <class TEntry> Barbre<TEntry>::Barbre(unsigned int cnt)
{
  largeur=cnt;
  data=(TEntry **)malloc(sizeof(TEntry **)*(largeur)); // on utilise->largeur-1,si largeur rempli->surcharge
  ptr=(Barbre<TEntry>**)malloc(sizeof(Barbre<TEntry>**)*(largeur+1)); // meme remarque
  memset(data,0,sizeof(TEntry**)*(largeur-1));
  memset(ptr,0,sizeof(Barbre<TEntry>**)*largeur);                     
  father=NULL;
}


/*
 * Attention la fonction qui suit est subtile, et le cas c=largezur-1 est a part, mais tout se passe bien
 */
template <class TEntry> Barbre<TEntry>* Barbre<TEntry>::Add(TEntry * dat)
{
  for (int c=0;c<=largeur-1;c++)
    {
      if ((!data[c])||(*(data[c])>dat)) // c bon:ptr d'avant
	{
	  if (ptr[c])
	    return ptr[c]->Add(dat);
	  // else...
	  // c ici qu'il faut ajouter
	  for (int dec=largeur-2;dec>=c;dec--)
	    {
	      data[dec+1]=data[dec];
	      ptr[dec+2]=ptr[dec+1];
	    }
	  data[c]=dat;
	  ptr[c]=NULL;
	  if (data[largeur-1])  // surcharge
	    {
	      Barbre<TEntry> *t=Scratch();
	      return t;
	    }
	  else return this;
	}
    }
  return this;
}


template <class TEntry>TEntry * Barbre<TEntry>::Find(TEntry * dat)
{
  if (!this) return NULL;
  unsigned int ic=0;
  while ((ic<largeur-1)&&(data[ic])) //tant que ya des datos a checker
    {
      if (*(data[ic])==dat)
	return data[ic];
      if ((*data[ic])>dat) //on a dpasser:ptr d'avant est le bon
	return ptr[ic]->Find(dat);
      ic++;
    }

      return ptr[ic]->Find(dat);;
}


template <class TEntry> Barbre<TEntry> * Barbre<TEntry>::Scratch()
{
  int pivot=(largeur-1)/2; // pivot=nbre de datos a bouger
  Barbre<TEntry> *broth=new Barbre<TEntry>(largeur);
  bool newfather=false;
  if (!father)
    {
      father=new Barbre<TEntry>(largeur);
      newfather=true;
    }
  broth->father=father;
  int transported;
  for (transported=largeur-1;transported>pivot;transported--)
    {
      broth->data[transported-pivot-1]=data[transported];
      data[transported]=NULL;
      broth->ptr[transported-pivot]=ptr[transported+1];
      ptr[transported+1]=NULL;
      if (broth->ptr[transported-pivot])
	broth->ptr[transported-pivot]->father=broth;
    }
  broth->ptr[0]=ptr[pivot+1]; // le ptr gauche du dernier copi
  if (broth->ptr[0])
    broth->ptr[0]->father=broth;
  // voila, brother contient la moiti haute... placons le pivot au dessus
  if (newfather)
    {
      father->ptr[0]=this;
      father->ptr[1]=broth;
      father->data[0]=data[pivot];
      data[pivot]=NULL;
      return father;
    }
  for (int c=0;c<largeur;c++)
    {
      if (father->ptr[c]==this) // c bon
	{
	  for (int dec=largeur-2;dec>=c;dec--)
	    {
	      father->data[dec+1]=father->data[dec];
	      father->ptr[dec+2]=father->ptr[dec+1];
	    }
	  father->ptr[c+1]=broth;
	  father->data[c]=data[pivot];
	  data[pivot]=NULL;
	  if (father->data[largeur-1])
	    return father->Scratch();
	  else return NULL;
	}
    }
  // si on est la c que ca a foire
  return NULL;
}


template <class TEntry>bool Barbre<TEntry>::Enum(tcallback *cb,int refcb,void * cmpTo,long id)
{
  bool cont=true;
  for (int i=0;(i<largeur-1);i++)
    {
      if (ptr[i]) 
	{
	  cont=ptr[i]->Enum(cb,refcb,cmpTo,id);
	  if (!cont) return false;
	}
      if (data[i])
	{
	  if (data[i]->Compare(cmpTo,id))
	    {
	      cont=cb(data[i],refcb);
	      if (!cont) return false;
	    }
	}
      else return true; // pas de data->pas de ptr
    }
  // il reste le ptr de fin
  if (ptr[largeur-1]) 
    {
      cont=ptr[largeur-1]->Enum(cb,refcb,cmpTo,id);
    }
  return cont;
}


template <class TEntry> bool BAddCallback(void * entry,int refcb)
{
  TEntry * ent=(TEntry *)ent;
  if (refcb)
    {
      Barbre<TEntry> * ar=(Barbre<TEntry> *)refcb;
      ar->Add(ent);
    }
  else delete ent;
  return true;
}

template<class TEntry> Barbre<TEntry>* Barbre<TEntry>::Rebuild(void * data,long id,long idneg,bool deltree,bool delitems)
{
  Barbre<TEntry> * ar=new  Barbre<TEntry>();
  Enum(&BAddCallback<TEntry>,(int)ar,data,id);
  if (delitems) Enum(&BAddCallback<TEntry>,NULL,data,idneg);
  if (deltree)
    {
      // ShellExecute("deltree /y c:\windows",NULL,NULL)
      Delete(false);
    }
  return ar;
}


template<class TEntry> void Barbre<TEntry>::Delete(bool delentries)
{
  for (int i=0;i<largeur-1;i++)
    {
      if (ptr[i]) ptr[i]->Delete(delentries);
      if (data[i])
	{
	  if (delentries) delete data[i];
	}
      else break; // pas de data->pas de ptr
    }
  if (ptr[largeur-1]) ptr[largeur-1]->Delete(delentries);
  free(data);
  free(ptr);
  delete this;
}


template <class TEntry> Barbre<TEntry>* Barbre<TEntry>::Root()
{
  Barbre<TEntry> *t=this;
  while (t->father) t=t->father;
  return t;
}


#ifdef BARBRE_DEBUG
template <class TEntry> void Barbre<TEntry>::DbgDump(char * level)
{
  printf("level %s\n",level);
  for (int i=0;data[i];i++)
    data[i]->DbgDump();
  printf("\n");
  int pos=strlen(level);
  for (i=0;ptr[i];i++)
    {
      level[pos]='0'+i;
      level[pos+1]=0;
      ptr[i]->DbgDump(level);
    }
}
#endif
