/* barbre.h
 *
 * Copyright (C) 2002 Matthieu Nottale <matthieu@nottale.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: barbre.h,v 1.2 2003/10/02 19:29:56 cos Exp $
 *
 */

#ifndef BABRE_
#define BABRE_

typedef bool (*tcallback)(void * entry,int refcb);


template <class TEntry>class Barbre
{
 private:
  unsigned int largeur; // nbre de ptrs pour chaque arbre(!doit etre const pour un arbre)
  TEntry ** data;
  Barbre<TEntry> ** ptr;                                
  Barbre<TEntry> * father;
  Barbre<TEntry> * Scratch();  // dsature l'arbre

 public:
  Barbre(unsigned int cnt);
  TEntry * Find(TEntry *); // nonnon c pas stupide,la tentry param doit juste avoir la bonne clef de trie
  void Remove(TEntry *);
  // rajoute une entree, renvoi le nouveau root
  Barbre<TEntry>* Add(TEntry *);
  bool Enum(tcallback * cb,int refcb,void * data,long id); // enum(other criteria than the sort one) 
  // build a new tree,containing only matches,and delete the other tree
  Barbre<TEntry> * Rebuild(void * data,long id,long idneg, bool deltree,bool delitems);
  void Delete(bool delentries);
  // renvoi le root
  Barbre<TEntry> * Root();
#ifdef BARBRE_DEBUG
  void DbgDump(char * level);
#endif
};

#include "barbre.C"

#endif

/* template <class C> */
/* { */
/*  void MyClass<C>::fonction() */
/* } */
