/* parseconfig.h - 'Magick' configuration file parser, can be used
 *                 to fill directly the structure that will be used
 *                 by the program
 *
 * Copyright (C) 2003 Matthieu Nottale <matthieu@nottale.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: parseconfig.h,v 1.3 2003/10/02 19:29:56 cos Exp $
 *
 */

/*#if SIZEOF(void *) != SIZEOF(long)
error!!! sizeof(void *) != sizeof(long)!!!  this will cause trouble
#endif*/

enum entrytype
{
  TYPE_STRING=1,
  TYPE_INTEGER,
  TYPE_BOOLEAN,
  TYPE_CUSTOM
};


struct configentry 
{
  char * key;
  enum entrytype type;
  char * customtype; // a format string useable by *scanf functions
  long multiple; // if true, value is filled with a ptr to a multiplevalues struct, otherwise the value is filled in directly
  long maxstringsize; // maximum size of a string (in case of a "%s" element in custom format)
};


struct multiplevalues
{
  long count;   // number of results, the size of a result is determined by customtype if it is a custom type
  long allocated; // allocated size of values
  void ** values;
};

/*
 * VALUES must be allocated, if VALUES|i] is a multipleentries, it must be either allocated and valid, or NULL 
 */
unsigned int parseconfig(char * filename, struct configentry *entries, void** values);

unsigned int fillconfig(char * filename, struct configentry *entries, void** values);
